(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('lodash'), require('@nyy/logger'), require('@angular/common'), require('@ngx-translate/http-loader'), require('url'), require('qs'), require('@angular/common/http'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@nyy/core', ['exports', '@angular/core', 'lodash', '@nyy/logger', '@angular/common', '@ngx-translate/http-loader', 'url', 'qs', '@angular/common/http', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nyy = global.nyy || {}, global.nyy.core = {}), global.ng.core, global.lodash, global.logger$4, global.ng.common, global.httpLoader, global.Url_, global.qs_, global.ng.common.http, global.rxjs));
}(this, (function (exports, core, lodash, logger$4, common, httpLoader, Url_, qs_, http, rxjs) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var Url___namespace = /*#__PURE__*/_interopNamespace(Url_);
    var qs___namespace = /*#__PURE__*/_interopNamespace(qs_);

    var logger = new logger$4.Logger('CORE:PRIVILEGE');
    var privilegeAppInjector = { injector: null };
    var privilegeInjectorRegister = function (injector) {
        Object.defineProperty(privilegeAppInjector, 'injector', {
            value: injector,
            enumerable: true,
            writable: false,
            configurable: false,
        });
    };
    var PrivilegeRequire = function (privileges) {
        return function (target, propertyKey, descriptor) {
            if (lodash.isFunction(descriptor.value)) {
                var originalMethod_1 = descriptor.value;
                descriptor.value = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var injector = privilegeAppInjector.injector;
                    logger.debug('privilegeAppInjector: %o', injector);
                    var service = injector.get(PrivilegeServiceToken, null);
                    logger.debug('privilege service: %o', service);
                    if (service && service.hasPrivilege(privileges)) {
                        // skip privilege
                        return originalMethod_1.apply(this, args);
                    }
                    else if (!service) {
                        return originalMethod_1.apply(this, args);
                    }
                };
            }
        };
    };
    var PrivilegeServiceToken = new core.InjectionToken('privilege_service_token');

    var logger$1 = new logger$4.Logger('CORE:PermissionRequire');
    var PrivilegeRequireDirective = /** @class */ (function () {
        function PrivilegeRequireDirective(viewContainerRef, templateRef, privilegeService) {
            this.viewContainerRef = viewContainerRef;
            this.templateRef = templateRef;
            this.privilegeService = privilegeService;
        }
        Object.defineProperty(PrivilegeRequireDirective.prototype, "privilegeRequire", {
            set: function (v) {
                if (!this.privilegeService) {
                    logger$1.debug('privilege service is not defined; should you register the privilege provider?');
                    this.viewContainerRef.createEmbeddedView(this.templateRef);
                }
                else if (this.privilegeService.hasPrivilege(v)) {
                    this.viewContainerRef.createEmbeddedView(this.templateRef);
                }
                else {
                    this.viewContainerRef.clear();
                }
            },
            enumerable: false,
            configurable: true
        });
        return PrivilegeRequireDirective;
    }());
    PrivilegeRequireDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[privilegeRequire]',
                },] }
    ];
    PrivilegeRequireDirective.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: core.TemplateRef },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [PrivilegeServiceToken,] }] }
    ]; };
    PrivilegeRequireDirective.propDecorators = {
        privilegeRequire: [{ type: core.Input }]
    };

    var PrivilegeModule = /** @class */ (function () {
        function PrivilegeModule() {
        }
        return PrivilegeModule;
    }());
    PrivilegeModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [PrivilegeRequireDirective],
                    imports: [
                        common.CommonModule,
                    ],
                    exports: [PrivilegeRequireDirective],
                },] }
    ];

    var logger$2 = new logger$4.Logger('CORE:I18N');
    var TRANSLATE_CONFIG = new core.InjectionToken('ngx-translate-config');
    var NgxTranslateHttpLoaderFactory = function (http, config) {
        logger$2.debug('[NgxTranslateHttpLoaderFactory][args]: %o', config);
        if (config) {
            logger$2.debug('[TRANSLATE_CONFIG]: %o', config);
            return new httpLoader.TranslateHttpLoader(http, config.path, config.suffix);
        }
        return new httpLoader.TranslateHttpLoader(http, '/assets/i18n/', '.json');
    };

    var MOCK_CONFIG = new core.InjectionToken('mock_config');

    var Url = Url___namespace;
    var qs = qs___namespace;
    var logger$3 = new logger$4.Logger('CORE:Mock');
    var MockInterceptor = /** @class */ (function () {
        function MockInterceptor(http, config) {
            if (config === void 0) { config = {}; }
            this.http = http;
            this.config = config;
        }
        MockInterceptor.prototype.intercept = function (request, next) {
            var mocks = this.config.modules;
            if (mocks && Object.keys(mocks).length) {
                var url = Url.parse(request.url);
                var method = request.method;
                var pathname = url.pathname;
                var mockPathWithMethod = method + " " + pathname;
                var mockDataGenerator = mocks[mockPathWithMethod];
                if (mockDataGenerator) {
                    var query = qs.parse(url.query);
                    var resBody = mockDataGenerator(query, request.params, request.body);
                    logger$3.debug('[Mock INFO]' +
                        '\n[Mock Request Url] => %s::%s ' +
                        '\n[Mock Request Body] => %o' +
                        '\n[Mock Response Body] => %o', request.method, request.url, request.body, resBody);
                    return rxjs.of(new http.HttpResponse({
                        status: 200,
                        body: resBody,
                    }));
                }
            }
            return next.handle(request);
        };
        return MockInterceptor;
    }());
    MockInterceptor.decorators = [
        { type: core.Injectable }
    ];
    MockInterceptor.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MOCK_CONFIG,] }] }
    ]; };

    /*
     * Public API Surface of core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.MOCK_CONFIG = MOCK_CONFIG;
    exports.MockInterceptor = MockInterceptor;
    exports.NgxTranslateHttpLoaderFactory = NgxTranslateHttpLoaderFactory;
    exports.PrivilegeModule = PrivilegeModule;
    exports.PrivilegeRequire = PrivilegeRequire;
    exports.PrivilegeRequireDirective = PrivilegeRequireDirective;
    exports.PrivilegeServiceToken = PrivilegeServiceToken;
    exports.TRANSLATE_CONFIG = TRANSLATE_CONFIG;
    exports.privilegeInjectorRegister = privilegeInjectorRegister;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nyy-core.umd.js.map
